from collections import defaultdict, deque
from datetime import datetime, timedelta
from enum import Enum
import pprint
import argparse


class ComponentType(Enum):
    BATT = 'BATT'
    TSTAT = 'TSTAT'


class ReadingLimit:
    def __init__(self, high: float = 1, low: float = 0):
        """
        Upper- and lower-bounds for satellite component readings
        :param high: float
        :param low: float
        """
        if low > high:
            raise ValueError("Low value is greater than high value", f'{high} < {low}')
        elif low == high:
            raise ValueError("Low value is equal to high value", f'{high} == {low}')
        self.high = high
        self.low = low


class SatelliteRecord:
    def __init__(self, timestamp: datetime, sat_id: int, red_limit: ReadingLimit, yellow_limit: ReadingLimit,
                 value: float, component: str):
        """
        Structured, time-based telemetry data
        :param timestamp: datetime
        :param sat_id: int
        :param red_limit: ReadingLimit
        :param yellow_limit: ReadingLimit
        :param value: float
        :param component: str
        """
        self.timestamp = timestamp
        self.sat_id = sat_id
        self.red_limit = red_limit
        self.yellow_limit = yellow_limit
        self.value = value
        self.component = ComponentType[component]

    def has_alert(self):
        """
        Returns True if the record value exceeds a components maximum or minimum threshold
        :return: bool
        """
        return (self.value > self.red_limit.high) or (self.value < self.red_limit.low)

    def generate_alert(self):
        """
        Creates a JSON object to specify alert message properties
        :return: Dict
        """
        if self.has_alert():
            alert_body = {
                "satelliteId": self.sat_id,
                "component": self.component.value,
                "timestamp": f'{self.timestamp.strftime("%Y-%m-%dT%H:%M:%S.%f")[:-3]}Z'
            }
            if self.value > self.red_limit.high:
                alert_body["severity"] = "RED HIGH"
            elif self.value < self.red_limit.low:
                alert_body["severity"] = "RED LOW"
            return alert_body


class AlertQueue:
    def __init__(self, window: int = 5):
        """
        Maintains a mapping of each satellite id and its associated component alerts
        :param window: int
        """
        self.battery_alerts: defaultdict[int, deque] = defaultdict(deque)
        self.thermostat_alerts: defaultdict[int, deque] = defaultdict(deque)

        self.delta = timedelta(minutes=window)
        self.start_time = datetime.fromtimestamp(0)
        self.end_time = self.start_time + self.delta

        self.json_outputs = []

    def enqueue(self, new_record: SatelliteRecord):
        """
        Store the satellites record based on the component type
        :param new_record: SatelliteRecord
        """
        if new_record.component == ComponentType.BATT:
            alerts = self.battery_alerts
        elif new_record.component == ComponentType.TSTAT:
            alerts = self.thermostat_alerts
        else:
            raise ValueError("Invalid ComponentType", new_record.component)

        if new_record.timestamp < self.end_time:
            alerts[new_record.sat_id].append(new_record)

            if len(alerts[new_record.sat_id]) > 2:
                alert = alerts[new_record.sat_id].popleft()
                self.json_outputs.append(alert.generate_alert())
        else:
            while alerts[new_record.sat_id] and new_record.timestamp > alerts[new_record.sat_id][-1].timestamp:
                alerts[new_record.sat_id].popleft()

            alerts[new_record.sat_id].append(new_record)
            self.start_time = new_record.timestamp
            self.end_time = self.start_time + self.delta

    def dequeue(self, record: SatelliteRecord):
        """
        Remove the satellite record from it's corresponding queue based on component type
        :param record: SatelliteRecord
        """
        if record.component == ComponentType.BATT:
            alerts = self.battery_alerts
        elif record.component == ComponentType.TSTAT:
            alerts = self.thermostat_alerts
        else:
            raise ValueError("Invalid ComponentType", record.component)

        if record.sat_id in alerts.keys():
            old_record = alerts[record.sat_id].popleft()
            return old_record

    def report_alerts(self):
        """
        Outputs any alerts that have been generated by enqueued records
        """
        (pprint.PrettyPrinter(indent=2)).pprint(self.json_outputs)


def create_telemetry_record(telemetry_data: str):
    data = telemetry_data.split('|')
    return SatelliteRecord(
        datetime.strptime(data[0], "%Y%m%d %H:%M:%S.%f"),
        int(data[1]),
        ReadingLimit(float(data[2]), float(data[4])),
        ReadingLimit(float(data[3]), float(data[5])),
        float(data[6]),
        data[7],
    )


def main(file_name: str):
    alert_queue = AlertQueue()
    with open(file_name) as file:
        for line in file:
            record = create_telemetry_record(line.strip())

            if not record.has_alert():
                continue

            alert_queue.enqueue(record)

    alert_queue.report_alerts()


if __name__ == '__main__':
    parser = argparse.ArgumentParser(description='Generate alert messages from status telemetry data')
    parser.add_argument('filename', help='Text file of pipe delimited records')
    args = parser.parse_args()
    main(args.filename)
